
/**range [0,1) */
function urandom()
{return syncRandom(16777216)/16777216}
/**uniform distribution [-scale,scale)*/
function uni(scale=1)
{return (urandom()-0.5)*2*scale}
/** 
 * @template T
 * @param {T[]} arr
 * @returns {T}
 * */
function choose(arr=[])
{return arr[parseInt(urandom()*arr.length)]}
/** 
 * @template T
 * @param {T[]} arr
 * @param {(x:T)=>Number} key
 * @returns {T}
 * */
function argmin(arr=[],key=parseInt)
{
    var k=arr.map(x=>key(x)).map(x=>isNaN(x)?Infinity:x)
    var kmin=Math.min(...(k.flat()))
    return k.findIndex(x=>x==kmin)
}
/**
 * @template T
 * @param {T[]} arr
 * @param {(x:T)=>Number} key
 * @returns {T}
 */
function min(arr=[],key=parseInt)
{return arr[argmin(arr,key)]}

function fuzzy(x="")
{return new RegExp(x.split("").reduce((a,b)=>a+".*?"+b), "i")}






include("multiplay/script/mods/sync.js");
var syncPrint=synchronize(print)
var syncAddDroid=synchronize(addDroid)

/** 
 * @returns {String[]}
*/
function enumStat(x=Stats.Building)
{return Object.keys(x).map(i=>x[i].Id)}

function itemFromName(stat=Stats.Building,name="")
{
    var k=min( Object.keys(stat).filter(i=>fuzzy(name).test(i)), i=>i.length )
    return stat[k].Id
}
/**"hvycan py htk" -> ["Body11ABT","HalfTrack",0,0,"Cannon375mmMk1"]*/
function templateFromName(x="")
{
    if (x.startsWith("*"))
    {
        x=x.slice(1)
        var cybwpn=Object.keys(Stats.Weapon).filter(i=>Stats.Weapon[i].Id.startsWith("Cyb"))
        var weapons=[Stats.Weapon[min( cybwpn.filter(i=>fuzzy(x).test(i)), i=>i.length )].Id]
        var body=(weapons[0].includes("Hvywpn"))?"CyborgHeavyBody":"CyborgLightBody"
        var prop="CyborgLegs"
    }
    else
    {
        var y=x.split(new RegExp(" +"))//weapon body prop
        var body=itemFromName(Stats.Body,y[y.length-2])
        var prop=itemFromName(Stats.Propulsion,y[y.length-1])
        var weapons=y.slice(0,y.length-2).map(i=>itemFromName(Stats.Weapon,i))
    }
    return [body,prop,0,0,...weapons]
}

function addTank(from)
{
    var home=startPositions[from]
    syncAddDroid(from,home.x,home.y,"tank",...templateFromName("gauss gauss dg hov"))
}
var syncAddTank=synchronize(addTank)

/** An event that is run whenever a chat message is received. The ```from``` parameter is the
player sending the chat message. For the moment, the ```to``` parameter is always the script
player. 
* @param {Number} from
* @param {Number} to
* @param {String} message
*/
function eventChat(from, to, message) 
{
    if (from!=me)return
    if (!message.startsWith("/"))return
    var argv=message.slice(1).split(new RegExp(" +"))
    if (argv[0]=="tank")
        syncAddTank(from)
    //syncPrint(...argv)//syncRequest(...argv.slice(0,3).map(i=>parseInt(i)))
}
